/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (I)         *
 *            - ץߥ󥰤δá꥽٥ -             *
 *                                                                     *
 *      Copyright 1994,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static Widget text, dialog, label;

/* ֥եץ˥塼ιܤФ줿ȤΥХå */
static void FileMenuCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    int menu_item = (int)client_data;  /* Ф줿˥塼ܤֹ */
    printf("File Menu: item %d is selected\n", menu_item);

    if (menu_item == 0)  /* 0 ܤΥ˥塼 (ֿ) ʤ */
        XmTextSetString(text, "");  /* ƥȤƤõ */

    if (menu_item == 1)  /* 1 ܤΥ˥塼 (֥ץ) ʤ */
        XtManageChild(dialog);  /* ե롦쥯󡦥Ф */

    if (menu_item == 3)  /* 3 ܤΥ˥塼 (ֽλ) ʤ */
        exit(0);         /* ץλ */
}

/*  [λ] ܥ󤬲줿ȤΥХå */
static void OpenFileCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];
    XmFileSelectionBoxCallbackStruct *cb =
                (XmFileSelectionBoxCallbackStruct *)call_data;

    /* ե̾ʸФ */
    XmStringGetLtoR(cb->value, XmFONTLIST_DEFAULT_TAG, &filename);

    /* ե򥪡ץ󤷤ƥƥȤ */
    XmTextSetString(text, "");  /* äƥȤƤõ */
    fp = fopen(filename, "r");  /* ե򥪡ץ */
    while (fgets(buff, BUFSIZ, fp) != NULL) {  /* ե뤫ɤ߹ */
        /* ɤ߹ǡƥȤɲ */
        XmTextInsert(text, XmTextGetLastPosition(text), buff);
    }
    fclose(fp);
    XtFree(filename);

    /* ե̾Υ٥ɽ */
    XtVaSetValues(label, XmNlabelString, cb->value, NULL);
    XtUnmanageChild(dialog); /* Ĥ */
}

/* ˥塼Сȥץ󡦥˥塼 */
static Widget CreateMenu(parent)
    Widget parent;
{
    Widget  menubar, filemenu;

    /* ˥塼С */
    menubar = XmVaCreateSimpleMenuBar(parent, "menubar",
                  XmVaCASCADEBUTTON, NULL, NULL,  /* ֥եץ˥塼 */
                  NULL);
    XtManageChild(menubar);

    /* ֥եץץ󡦥˥塼 */
    filemenu = XmVaCreateSimplePulldownMenu(menubar, "filemenu", 0, FileMenuCB,
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֿ */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֥ץ */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ݴɡ */
                  XmVaSEPARATOR,  /* ѥ졼 (˥塼ܤζڤ) */
                  XmVaPUSHBUTTON, NULL, NULL, NULL, NULL,  /* ֽλ */
                  NULL);

    return(menubar);
}

/* Ф줿ƥȤ򥯥åץܡɤ˥ԡ */
static void CopyCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextCopy(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* Ф줿ƥȤ򥯥åץܡɤ˥å */
static void CutCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextCut(text, XtLastTimestampProcessed(XtDisplay(text)));
}

/* åץܡɤΥǡƥȤ˥ڡ */
static void PasteCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    XmTextPaste(text);
}

/* ޥΰ */
static Widget CreateCommandArea(parent)
    Widget parent;
{
    Widget command, copy, cut, paste;
    Arg    al[20];
    int    ac;

    ac = 0;
    command = XmCreateRowColumn(parent, "command", al, ac);
    XtManageChild(command);

    /* [ԡ][å][ڡ] ܥ */
    ac = 0;
    copy = XmCreatePushButton(command, "copy", al, ac);
    XtManageChild(copy);
    ac = 0;
    cut = XmCreatePushButton(command, "cut", al, ac);
    XtManageChild(cut);
    ac = 0;
    paste = XmCreatePushButton(command, "paste", al, ac);
    XtManageChild(paste);

    XtAddCallback(copy,  XmNactivateCallback, CopyCB,  NULL);
    XtAddCallback(cut,   XmNactivateCallback, CutCB,   NULL);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);

    return command;
}

/* åΰ */
static Widget CreateMessageArea(parent)
    Widget parent;
{
    Widget message, frame, ftitle, form, ltitle;
    Arg    al[20];
    int    ac;

    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth,  8); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 8); ac++;
    message = XmCreateRowColumn(parent, "message", al, ac);
    XtManageChild(message);

    /* ե졼γȤǰϤ */
    ac = 0;
    XtSetArg(al[ac], XmNmarginWidth,  8); ac++;
    XtSetArg(al[ac], XmNmarginHeight, 8); ac++;
    frame = XmCreateFrame(message, "frame", al, ac);
    XtManageChild(frame);

    /* ե졼˥ȥդ */
    ac = 0;
    XtSetArg(al[ac], XmNchildType,                XmFRAME_TITLE_CHILD); ac++;
    XtSetArg(al[ac], XmNchildHorizontalAlignment, XmALIGNMENT_CENTER); ac++;
    XtSetArg(al[ac], XmNmarginWidth,              10); ac++;
    ftitle = XmCreateLabel(frame, "ftitle", al, ac);
    XtManageChild(ftitle);

    /* եǻҥåȤ쥤 */
    ac = 0;
    form = XmCreateForm(frame, "form", al, ac);
    XtManageChild(form);

    /* [ե̾:] Υ٥Τ¦֤ */
    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition,     0); ac++;
    XtSetArg(al[ac], XmNrightAttachment,  XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition,    50); ac++;
    XtSetArg(al[ac], XmNrightOffset,      4); ac++;
    XtSetArg(al[ac], XmNalignment,        XmALIGNMENT_END); ac++;
    XtSetArg(al[ac], XmNresizable,        False); ac++;
    ltitle = XmCreateLabel(form, "ltitle", al, ac);
    XtManageChild(ltitle);

    /* ץ󤷤ե̾Τ¦֤ */
    ac = 0;
    XtSetArg(al[ac], XmNtopAttachment,    XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNbottomAttachment, XmATTACH_FORM); ac++;
    XtSetArg(al[ac], XmNleftAttachment,   XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNleftPosition,     50); ac++;
    XtSetArg(al[ac], XmNleftOffset,       4); ac++;
    XtSetArg(al[ac], XmNrightAttachment,  XmATTACH_POSITION); ac++;
    XtSetArg(al[ac], XmNrightPosition,    100); ac++;
    XtSetArg(al[ac], XmNalignment,        XmALIGNMENT_BEGINNING); ac++;
    XtSetArg(al[ac], XmNresizable,        False); ac++;
    label = XmCreateLabel(form, "label", al, ac);
    XtManageChild(label);

    return message;
}

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, mainwin, menubar, work, command, message;
    Arg    al[20];
    int    ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Editor", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
        /* ᥤ󡦥ɥڤ (ѥ졼) ɽ */
    XtSetArg(al[ac], XmNshowSeparator, True); ac++;
        /* ޥΰΰβ֤ */
    XtSetArg(al[ac], XmNcommandWindowLocation, XmCOMMAND_BELOW_WORKSPACE); ac++;
        /* ᥤ󡦥ɥ */
    mainwin = XmCreateMainWindow(toplevel, "mainwin", al, ac);
    XtManageChild(mainwin);

    menubar = CreateMenu(mainwin); /* ˥塼 */

        /* ΰ */
    ac = 0;
    work = XmCreateRowColumn(mainwin, "work", al, ac);
    XtManageChild(work);
    ac = 0;
    text = XmCreateText(work, "text", al, ac);
    XtManageChild(text);

        /* ޥΰ */
    command = CreateCommandArea(mainwin);
        /* åΰ */
    message = CreateMessageArea(mainwin);

        /* ΰᥤ󡦥ɥ */
    XmMainWindowSetAreas(mainwin, menubar, command, NULL, NULL, work);
        /* åΰϥ꥽ */
    XtVaSetValues(mainwin, XmNmessageWindow, message, NULL);

        /* ե롦쥯󡦥 */
    ac = 0;
    dialog = XmCreateFileSelectionDialog(toplevel, "dialog", al, ac);
    XtAddCallback(dialog, XmNokCallback, OpenFileCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
